## libxml2 2.13.3+dfsg

=== debian/changelog ===
libxml2 (2.13.3+dfsg-0exp2) experimental; urgency=medium

  * d/control: add Provides: libxml2 (= ${source:Version})
    temporarily to reduce breakage during transition

 -- Aron Xu <aron@debian.org>  Sat, 24 Aug 2024 18:13:02 +0800

libxml2 (2.13.3+dfsg-0exp1) experimental; urgency=medium

  * New upstream release
  * Rename binary package libxml2 to libxml2n for new ABI without
    bumping the actual library SONAME

 -- Aron Xu <aron@debian.org>  Fri, 16 Aug 2024 22:13:37 +0800

libxml2 (2.13.1+dfsg-0exp1) experimental; urgency=medium

  * New upstream release
  * d/libxml2.symbols: update symbols

 -- Aron Xu <aron@debian.org>  Sat, 29 Jun 2024 14:45:40 +0800

=== debian/control ===
Source: libxml2
Priority: optional
Section: libs
Maintainer: Debian XML/SGML Group <debian-xml-sgml-pkgs@lists.alioth.debian.org>
Uploaders:
 Aron Xu <aron@debian.org>,
 YunQiang Su <wzssyqa@gmail.com>,
Build-Depends:
 debhelper-compat (= 13),
Build-Depends-Indep:
 pkgconf,
Build-Depends-Arch:
 dh-sequence-python3 <!nopython>,
 libicu-dev <!noi18n>,
 liblzma-dev,
 libpython3-all-dev <!nopython>,
 pkgconf,
 python3-all-dev:any (>= 3.5) <!nopython>,
 python3-setuptools,
 rename,
 zlib1g-dev | libz-dev,
Standards-Version: 4.6.2
Rules-Requires-Root: no
Homepage: http://xmlsoft.org
Vcs-Git: https://salsa.debian.org/xml-sgml-team/libxml2.git
Vcs-Browser: https://salsa.debian.org/xml-sgml-team/libxml2
Description: GNOME XML library
 XML is a metalanguage to let you design your own markup language.
 A regular markup language defines a way to describe information in
 a certain class of documents (eg HTML). XML lets you define your
 own customized markup languages for many classes of document. It
 can do this because it's written in SGML, the international standard
 metalanguage for markup languages.

Package: libxml2n
Architecture: any
Pre-Depends:
 ${misc:Pre-Depends},
Depends:
 ${misc:Depends},
 ${shlibs:Depends},
Provides: libxml2 (= ${source:Version})
Conflicts:
 w3c-dtd-xhtml,
Breaks:
 libxml-libxml-perl (<< 2.0207+dfsg+really+2.0134-3~),
 libxml2 (<< ${source:Version}),
Replaces: libxml2
Multi-Arch: same
Description: ${source:Synopsis}
 ${source:Extended-Description}
 .
 This package provides a library providing an extensive API to handle
 such XML data files.

Package: libxml2-utils
Architecture: any
Section: text
Depends:
 ${misc:Depends},
 ${shlibs:Depends},
Multi-Arch: foreign
Description: ${source:Synopsis} - utilities
 ${source:Extended-Description}
 .
 This package provides xmllint, a tool for validating and reformatting
 XML documents, and xmlcatalog, a tool to parse and manipulate XML or
 SGML catalog files.

Package: libxml2-dev
Architecture: any
Section: libdevel
Depends:
 libicu-dev,
 liblzma-dev,
 libxml2n (= ${binary:Version}),
 zlib1g-dev,
 ${misc:Depends},
Suggests:
 pkgconf,
Multi-Arch: same
Description: ${source:Synopsis} - development files
 ${source:Extended-Description}
 .
 Install this package if you wish to develop your own programs using
 the GNOME XML library.

Package: libxml2-doc
Architecture: all
Section: doc
Depends:
 ${misc:Depends},
Suggests:
 devhelp,
Multi-Arch: foreign
Description: ${source:Synopsis} - documentation
 ${source:Extended-Description}
 .
 This package contains general information about the GNOME XML library
 and more specific API references.

Package: python3-libxml2
Architecture: any
Build-Profiles: <!nopython>
Section: python
Depends:
 ${misc:Depends},
 ${python3:Depends},
 ${shlibs:Depends},
Description: ${source:Synopsis} - Python3 bindings
 ${source:Extended-Description}
 .
 This package contains the files needed to use the GNOME XML library
 in Python3 programs.

=== debian/rules ===
#!/usr/bin/make -f
export DH_VERBOSE=1

DOPACKAGES = $(shell dh_listpackages)

ifneq (,$(filter python3-libxml2,$(DOPACKAGES)))
# The versions of python3 currently supported
PY3VERS=$(shell py3versions -s)
else
PY3VERS=
endif

export DEB_BUILD_MAINT_OPTIONS=hardening=+all
export DEB_CFLAGS_MAINT_APPEND = -Wall -O3

include /usr/share/dpkg/architecture.mk

TARGETS := main $(PY3VERS)

CONFIGURE_FLAGS := --with-history \
		   --with-legacy \
		   --with-ftp \
		   --with-xptr-loc

override_dh_auto_configure-arch: $(TARGETS:%=doconfigure-%)

override_dh_auto_configure-indep:
	dh_auto_configure -- --docdir \$${prefix}/share/doc/libxml2 --enable-rebuild-docs --with-python=no

doconfigure-%:
	export PYTHON=$(PYTHON) && dh_auto_configure --builddirectory=builddir/$(*) -- $(CONFIGURE_FLAGS) && unset PYTHON
	touch $@

ifeq (,$(filter noi18n,$(DEB_BUILD_PROFILES)))
doconfigure-main: CONFIGURE_FLAGS += --with-python=no --with-icu
else
doconfigure-main: CONFIGURE_FLAGS += --with-python=no
endif
doconfigure-python%: CONFIGURE_FLAGS += --with-python
	#PYTHON_VERSION=$(subst python,,$(*))
	PYTHON=$(shell which $(*))

dobuild-%: BUILD_DIR=builddir/$(*)
dobuild-%: doconfigure-%
	$(if $(filter $(BUILD_DIR),builddir/$(*)),,[ -d $(BUILD_DIR) ] || mv builddir/$(*)/python $(BUILD_DIR))
	dh_auto_build --builddirectory=$(BUILD_DIR) -- $(BUILD_FLAGS)

dobuild-python%: BUILD_DIR=builddir/main/$(*)
dobuild-python%: BUILD_FLAGS=libxml2mod_la_LIBADD='$$(mylibs)' \
    PYTHON_INCLUDES='$(shell $(DEB_HOST_GNU_TYPE)-$(*)-config --includes)' \
    PYTHON_LIBS='$(shell $(DEB_HOST_GNU_TYPE)-$(*)-config --ldflags)'

override_dh_auto_build-arch: $(TARGETS:%=dobuild-%)

override_dh_auto_build-indep:
	dh_auto_build -i

override_dh_auto_test-indep:
	: Skipping tests during indep build

execute_after_dh_auto_clean:
	rm -rf builddir
	rm -f doconfigure-*

doinstall-main:
	dh_auto_install --builddirectory=builddir/main
	mv debian/tmp/usr/share/aclocal/libxml.m4 debian/tmp/usr/share/aclocal/libxml2.m4

override_dh_auto_install-arch: $(TARGETS:%=doinstall-%)
	find debian/tmp -name *.la -delete
	rm -r debian/tmp/usr/lib/python*/site-packages/__pycache__

doinstall-python%:
	dh_auto_install --builddirectory=builddir/main/python$(*)

override_dh_compress:
	dh_compress -Xexamples/ -Xtutorial/ -Xhtml/ -X.html

override_dh_installchangelogs:
	dh_installchangelogs -k NEWS

override_dh_install-arch:
	dh_install -a
	sed -i -e 's,/lib/$(DEB_HOST_MULTIARCH),/lib,' debian/libxml2-dev/usr/bin/xml2-config

override_dh_makeshlibs:
	dh_makeshlibs -plibxml2n -V 'libxml2n (>= 2.9.11)' -- -c4
	dh_makeshlibs --remaining-packages

#  I need to specify all the targets (build, binary, clean, etc) as
#  otherwise dh may invoke them in a order that is not appropriate for the
#  build system (the -indep part is done in-tree because rebuilding the
#  docs out of tree is not supported.  And once an in-tree build is done no
#  out-of-tree builds can be done, so we wouldn't be able to do the -arch
#  builds after the -indep one).
clean build-arch binary-arch build-indep binary-indep:
	dh $@

build: build-arch build-indep
binary: binary-arch binary-indep

dfsg-source-tree:
	rm -rf test/
	rm -rf result/

## libxml2 2.14.4+dfsg

=== debian/changelog ===
libxml2 (2.14.4+dfsg-0exp1) experimental; urgency=medium

  * Non-maintainer upload.
  * New upstream release.

 -- Matthias Klose <doko@debian.org>  Sat, 05 Jul 2025 20:59:44 +0200

libxml2 (2.14.3+dfsg-0exp3) experimental; urgency=medium

  * Non-maintainer upload.
  * parser: Fix custom SAX parsers without cdataBlock handler.
    Patch taken from the 2.14 branch. Closes: #1106645.

 -- Matthias Klose <doko@debian.org>  Tue, 03 Jun 2025 21:43:20 +0200

libxml2 (2.14.3+dfsg-0exp2) experimental; urgency=medium

  * Non-maintainer upload.
  * Explicity configure --with-http --with-lzma.
  * Update symbols file.

 -- Matthias Klose <doko@debian.org>  Mon, 02 Jun 2025 13:38:30 +0200

libxml2 (2.14.3+dfsg-0exp1) experimental; urgency=medium

  * Non-maintainer upload.
  * New upstream release.

 -- Matthias Klose <doko@debian.org>  Tue, 20 May 2025 07:13:43 +0200

libxml2 (2.14.2+dfsg-0exp1) experimental; urgency=medium

  * Non-maintainer upload.
  * New upstream release.

 -- Matthias Klose <doko@debian.org>  Wed, 23 Apr 2025 07:52:17 +0200

libxml2 (2.14.1+dfsg-0exp1) experimental; urgency=medium

  * Non-maintainer upload.
  * New upstream release. Addresses: #1102294.
  * New package libxml2-16 with new soname.
  * No more conflicts/breaks replaces with libxml2.
  * Update symbols file.
  * Refresh patches.
  * Configure without ICU, see 2.12.7+dfsg+really2.9.14-0.4.
  * Configure --with-readline; --with-history requires it.

 -- Matthias Klose <doko@debian.org>  Mon, 07 Apr 2025 13:48:29 +0200

=== debian/rules ===
--- 
+++ 
@@ -20,7 +20,9 @@
 CONFIGURE_FLAGS := --with-history \
 		   --with-legacy \
 		   --with-ftp \
-		   --with-xptr-loc
+		   --with-xptr-loc \
+		   --with-http \
+		   --with-lzma \
 
 override_dh_auto_configure-arch: $(TARGETS:%=doconfigure-%)
 
@@ -32,7 +34,7 @@
 	touch $@
 
 ifeq (,$(filter noi18n,$(DEB_BUILD_PROFILES)))
-doconfigure-main: CONFIGURE_FLAGS += --with-python=no --with-icu
+doconfigure-main: CONFIGURE_FLAGS += --with-python=no
 else
 doconfigure-main: CONFIGURE_FLAGS += --with-python=no
 endif
@@ -64,7 +66,6 @@
 
 doinstall-main:
 	dh_auto_install --builddirectory=builddir/main
-	mv debian/tmp/usr/share/aclocal/libxml.m4 debian/tmp/usr/share/aclocal/libxml2.m4
 
 override_dh_auto_install-arch: $(TARGETS:%=doinstall-%)
 	find debian/tmp -name *.la -delete
@@ -84,7 +85,7 @@
 	sed -i -e 's,/lib/$(DEB_HOST_MULTIARCH),/lib,' debian/libxml2-dev/usr/bin/xml2-config
 
 override_dh_makeshlibs:
-	dh_makeshlibs -plibxml2n -V 'libxml2n (>= 2.9.11)' -- -c4
+	dh_makeshlibs -plibxml2-16 -V 'libxml2-16 (>= 2.14.1)' -- -c4
 	dh_makeshlibs --remaining-packages
 
 #  I need to specify all the targets (build, binary, clean, etc) as

## libxml2 2.14.5+dfsg

=== meson_options.txt ===

# AC_ARG_WITH / AC_ARG_ENABLE in configure.ac
# [X] c14n
# [X] catalog
# [X] debugging
# [X] history
# [X] html
# [X] http
# [X] iconv
# [X] icu         - not minimum
# [X] iso8859x
# [X] legacy
# [X] lzma
# [X] modules
# [X] output
# [X] pattern
# [X] push
# [ ] python
# [X] reader
# [X] readline
# [X] regexps
# [X] sax1
# [X] schemas
# [X] schematron
# [X] threads
# [X] thread-alloc
# [X] tls
# [X] valid
# [X] writer
# [X] xinclude
# [X] xpath
# [X] xptr
# [X] zlib

# [X] minimum

option('c14n',
  type: 'feature',
  description: 'Canonical XML 1.0 support'
)

option('catalog',
  type: 'feature',
  description: 'XML Catalogs support'
)

option('debugging',
  type: 'feature',
  description: 'Debugging module and shell'
)

option('history',
  type: 'feature',
  description: 'History support for shell'
)

option('html',
  type: 'feature',
  description: 'HTML parser'
)

option('http',
  type: 'feature',
  description: 'HTTP support'
)

# TODO meson custom dependency
option('iconv',
  type: 'feature',
  description: 'iconv support'
)

option('icu',
  type: 'feature',
  value: 'disabled',
  description: 'ICU support'
)

option('iso8859x',
  type: 'feature',
  description: 'ISO-8859-X support if no iconv'
)

option('legacy',
  type: 'feature',
  value: 'disabled',
  description: 'Maximum ABI compatibility'
)

option('lzma',
  type: 'feature',
  description: 'LZMA support'
)

option('modules',
  type: 'feature',
  description: 'Dynamic modules support'
)

option('output',
  type: 'feature',
  description: 'Serialization support'
)

option('pattern',
  type: 'feature',
  description: 'xmlPattern selection interface'
)

option('push',
  type: 'feature',
  description: 'push parser interfaces'
)

option('python',
  type: 'feature',
  description: 'Python bindings'
)

option('reader',
  type: 'feature',
  description: 'xmlReader parsing interface'
)

option('readline',
  type: 'feature',
  description: 'use readline for shell history'
)

option('regexps',
  type: 'feature',
  description: 'Regular expressions support'
)

option('relaxng',
  type: 'feature',
  description: 'RELAX NG support'
)

option('sax1',
  type: 'feature',
  description: 'Older SAX1 interface'
)

option('schemas',
  type: 'feature',
  description: 'XML Schemas 1.0 support'
)

option('schematron',
  type: 'feature',
  description: 'Schematron support'
)

option('threads',
  type: 'feature',
  description: 'Multithreading support'
)

option('thread-alloc',
  type: 'feature',
  value: 'disabled',
  description: 'per-thread malloc hooks'
)

option('tls',
  type: 'feature',
  value: 'disabled',
  description: 'thread-local storage'
)

option('valid',
  type: 'feature',
  description: 'DTD validation support'
)

option('writer',
  type: 'feature',
  description: 'xmlWriter serialization interface'
)

option('xinclude',
  type: 'feature',
  description: 'XInclude 1.0 support'
)

option('xpath',
  type: 'feature',
  description: 'XPath 1.0 support'
)

option('xptr',
  type: 'feature',
  description: 'XPointer support'
)

option('zlib',
  type: 'feature',
  description: 'ZLIB support'
)

option('minimum',
  type: 'boolean',
  value: false,
  description: 'build a minimally sized library'
)

=== debian/changelog ===
libxml2 (2.14.5+dfsg-0exp2) experimental; urgency=medium

  * Non-maintainer upload.
  * Explicity configure with --enable-static and install the static
    libxml2.a library. LP: #2118828.

 -- Matthias Klose <doko@debian.org>  Mon, 28 Jul 2025 13:55:39 +0200

libxml2 (2.14.5+dfsg-0exp1) experimental; urgency=medium

  * Non-maintainer upload.
  * New upstream release.

 -- Matthias Klose <doko@debian.org>  Sat, 19 Jul 2025 11:38:53 +0200

=== debian/control ===
--- 
+++ 
@@ -11,7 +11,6 @@
  pkgconf,
 Build-Depends-Arch:
  dh-sequence-python3 <!nopython>,
- libicu-dev <!noi18n>,
  liblzma-dev,
  libpython3-all-dev <!nopython>,
  pkgconf,
@@ -19,6 +18,7 @@
  python3-setuptools,
  rename,
  zlib1g-dev | libz-dev,
+ libreadline-dev,
 Standards-Version: 4.6.2
 Rules-Requires-Root: no
 Homepage: http://xmlsoft.org
@@ -32,20 +32,17 @@
  can do this because it's written in SGML, the international standard
  metalanguage for markup languages.
 
-Package: libxml2n
+Package: libxml2-16
 Architecture: any
 Pre-Depends:
  ${misc:Pre-Depends},
 Depends:
  ${misc:Depends},
  ${shlibs:Depends},
-Provides: libxml2 (= ${source:Version})
 Conflicts:
  w3c-dtd-xhtml,
 Breaks:
  libxml-libxml-perl (<< 2.0207+dfsg+really+2.0134-3~),
- libxml2 (<< ${source:Version}),
-Replaces: libxml2
 Multi-Arch: same
 Description: ${source:Synopsis}
  ${source:Extended-Description}
@@ -71,9 +68,8 @@
 Architecture: any
 Section: libdevel
 Depends:
- libicu-dev,
  liblzma-dev,
- libxml2n (= ${binary:Version}),
+ libxml2-16 (= ${binary:Version}),
  zlib1g-dev,
  ${misc:Depends},
 Suggests:

=== debian/rules ===
--- 
+++ 
@@ -34,9 +34,9 @@
 	touch $@
 
 ifeq (,$(filter noi18n,$(DEB_BUILD_PROFILES)))
-doconfigure-main: CONFIGURE_FLAGS += --with-python=no
+doconfigure-main: CONFIGURE_FLAGS += --with-python=no --enable-static
 else
-doconfigure-main: CONFIGURE_FLAGS += --with-python=no
+doconfigure-main: CONFIGURE_FLAGS += --with-python=no --enable-static
 endif
 doconfigure-python%: CONFIGURE_FLAGS += --with-python
 	#PYTHON_VERSION=$(subst python,,$(*))
@@ -70,6 +70,7 @@
 override_dh_auto_install-arch: $(TARGETS:%=doinstall-%)
 	find debian/tmp -name *.la -delete
 	rm -r debian/tmp/usr/lib/python*/site-packages/__pycache__
+	rm -f debian/tmp/usr/lib/python*/site-packages/*.a
 
 doinstall-python%:
 	dh_auto_install --builddirectory=builddir/main/python$(*)

## libxml2 2.14.6+dfsg

=== CMakeLists.txt ===
cmake_minimum_required(VERSION 3.18)

file(READ "VERSION" VERSION)
string(STRIP ${VERSION} VERSION)
if(${VERSION} MATCHES [[([0-9]+)\.([0-9]+)\.([0-9]+)]])
    set(LIBXML_MAJOR_VERSION ${CMAKE_MATCH_1})
    set(LIBXML_MINOR_VERSION ${CMAKE_MATCH_2})
    set(LIBXML_MICRO_VERSION ${CMAKE_MATCH_3})
endif()

project(libxml2 VERSION ${VERSION} LANGUAGES C)

set(CMAKE_C_STANDARD 11)

include(CheckCSourceCompiles)
include(CheckFunctionExists)
include(CheckIncludeFiles)
include(CheckLibraryExists)
include(CheckStructHasMember)
include(CheckSymbolExists)
include(CMakeDependentOption)
include(CMakePackageConfigHelpers)
include(FindPkgConfig)
include(GNUInstallDirs)

option(BUILD_SHARED_LIBS "Build shared libraries" ON)
option(LIBXML2_WITH_CATALOG "Add the Catalog support" ON)
option(LIBXML2_WITH_DEBUG "Add the debugging module" ON)
option(LIBXML2_WITH_HTML "Add the HTML support" ON)
option(LIBXML2_WITH_HTTP "Add the HTTP support" OFF)
option(LIBXML2_WITH_ICONV "Add ICONV support" ON)
option(LIBXML2_WITH_ICU "Add ICU support" OFF)
option(LIBXML2_WITH_ISO8859X "Add ISO8859X support if no iconv" ON)
option(LIBXML2_WITH_LEGACY "Add deprecated APIs for compatibility" OFF)
option(LIBXML2_WITH_LZMA "Use liblzma" OFF)
option(LIBXML2_WITH_MODULES "Add the dynamic modules support" ON)
option(LIBXML2_WITH_OUTPUT "Add the serialization support" ON)
option(LIBXML2_WITH_PATTERN "Add the xmlPattern selection interface" ON)
option(LIBXML2_WITH_PROGRAMS "Build programs" ON)
option(LIBXML2_WITH_PUSH "Add the PUSH parser interfaces" ON)
option(LIBXML2_WITH_PYTHON "Build Python bindings" ON)
option(LIBXML2_WITH_READLINE "readline support for xmllint shell" OFF)
option(LIBXML2_WITH_REGEXPS "Add Regular Expressions support" ON)
option(LIBXML2_WITH_SAX1 "Add the older SAX1 interface" ON)
option(LIBXML2_WITH_TESTS "Build tests" ON)
option(LIBXML2_WITH_THREADS "Add multithread support" ON)
option(LIBXML2_WITH_TLS "Enable thread-local storage" OFF)
option(LIBXML2_WITH_VALID "Add the DTD validation support" ON)
option(LIBXML2_WITH_XINCLUDE "Add the XInclude support" ON)
option(LIBXML2_WITH_XPATH "Add the XPATH support" ON)

cmake_dependent_option(
    LIBXML2_WITH_ZLIB "Use libz" OFF
    "NOT LIBXML2_WITH_LEGACY" ON)

cmake_dependent_option(
    LIBXML2_WITH_C14N "Add the Canonicalization support" ON
    "LIBXML2_WITH_OUTPUT;LIBXML2_WITH_XPATH" OFF)
cmake_dependent_option(
    LIBXML2_WITH_HISTORY "history support for xmllint shell" OFF
    "LIBXML2_WITH_READLINE" OFF)
cmake_dependent_option(
    LIBXML2_WITH_READER "Add the xmlReader parsing interface" ON
    "LIBXML2_WITH_PUSH" OFF)
cmake_dependent_option(
    LIBXML2_WITH_SCHEMAS "Add XML Schemas 1.0 support" ON
    "LIBXML2_WITH_PATTERN;LIBXML2_WITH_REGEXPS" OFF)
cmake_dependent_option(
    LIBXML2_WITH_SCHEMATRON "Add Schematron support" ON
    "LIBXML2_WITH_PATTERN;LIBXML2_WITH_XPATH" OFF)
cmake_dependent_option(
    LIBXML2_WITH_THREAD_ALLOC "Add per-thread malloc hooks" OFF
    "LIBXML2_WITH_THREADS" OFF)
cmake_dependent_option(
    LIBXML2_WITH_WRITER "Add the xmlWriter saving interface" ON
    "LIBXML2_WITH_OUTPUT;LIBXML2_WITH_PUSH" OFF)
cmake_dependent_option(
    LIBXML2_WITH_XPTR "Add the XPointer support" ON
    "LIBXML2_WITH_XPATH" OFF)

cmake_dependent_option(
    LIBXML2_WITH_RELAXNG "Add Relax-NG support" ON
    "LIBXML2_WITH_REGEXPS;LIBXML2_WITH_SCHEMAS" OFF)

if(LIBXML2_WITH_PYTHON)
    find_package(Python COMPONENTS Interpreter Development REQUIRED)
    #set(LIBXML2_PYTHON_INSTALL_DIR ${Python_SITEARCH} CACHE PATH "Python bindings install directory")
    set(LIBXML2_PYTHON_INSTALL_DIR "${CMAKE_INSTALL_PREFIX}/python"
        CACHE PATH "Python bindings install directory")
endif()

foreach(VARIABLE IN ITEMS WITH_C14N WITH_CATALOG WITH_DEBUG WITH_HTML WITH_HTTP WITH_ICONV WITH_ICU WITH_ISO8859X WITH_LZMA WITH_MODULES WITH_OUTPUT WITH_PATTERN WITH_PUSH WITH_READER WITH_REGEXPS WITH_RELAXNG WITH_SAX1 WITH_SCHEMAS WITH_SCHEMATRON WITH_THREADS WITH_THREAD_ALLOC WITH_VALID WITH_WRITER WITH_XINCLUDE WITH_XPATH WITH_XPTR WITH_ZLIB)
    if(LIBXML2_${VARIABLE})
        set(${VARIABLE} 1)
    else()
        set(${VARIABLE} 0)
    endif()
endforeach()

set(LIBXML_VERSION ${VERSION})
set(LIBXML_VERSION_EXTRA "")
math(EXPR LIBXML_VERSION_NUMBER "
    ${LIBXML_MAJOR_VERSION} * 10000 +
    ${LIBXML_MINOR_VERSION} * 100 +
    ${LIBXML_MICRO_VERSION}
")

set(MODULE_EXTENSION "${CMAKE_SHARED_LIBRARY_SUFFIX}")

if(LIBXML2_WITH_ICONV)
    find_package(Iconv REQUIRED)
endif()

if(LIBXML2_WITH_ICU)
    find_package(ICU REQUIRED COMPONENTS uc)
endif()

if(LIBXML2_WITH_LZMA)
    find_package(LibLZMA REQUIRED)
endif()

if(LIBXML2_WITH_THREADS)
    find_package(Threads REQUIRED)
    set(THREAD_LIBS ${CMAKE_THREAD_LIBS_INIT})
    list(APPEND CMAKE_REQUIRED_LIBRARIES Threads::Threads)
endif()

if(LIBXML2_WITH_ZLIB)
    find_package(ZLIB REQUIRED)
endif()

check_c_source_compiles("
    void __attribute__((destructor))
    f(void) {}
    int main(void) { return 0; }
" HAVE_FUNC_ATTRIBUTE_DESTRUCTOR)
check_symbol_exists(getentropy "sys/random.h" HAVE_DECL_GETENTROPY)
check_symbol_exists(glob "glob.h" HAVE_DECL_GLOB)
check_symbol_exists(mmap "sys/mman.h" HAVE_DECL_MMAP)
check_include_files(stdint.h HAVE_STDINT_H)

if(LIBXML2_WITH_READLINE)
    check_library_exists(readline readline "" HAVE_LIBREADLINE)
    if (LIBXML2_WITH_HISTORY)
        check_library_exists(history append_history "" HAVE_LIBHISTORY)
    endif()
endif()

if(LIBXML2_WITH_HTTP)
    check_include_files(poll.h HAVE_POLL_H)
endif()

if(LIBXML2_WITH_TLS)
    check_c_source_compiles(
        "_Thread_local int v; int main(){return 0;}"
        XML_THREAD_LOCAL_C11
    )
    if (XML_THREAD_LOCAL_C11)
        set(XML_THREAD_LOCAL "_Thread_local")
    else()
        check_c_source_compiles(
            "__thread int v; int main(){return 0;}"
            XML_THREAD_LOCAL_THREAD
        )
        if (XML_THREAD_LOCAL_THREAD)
            set(XML_THREAD_LOCAL "__thread")
        else()
            check_c_source_compiles(
                "__declspec(thread) int v; int main(){return 0;}"
                XML_THREAD_LOCAL_DECLSPEC
            )
            if (XML_THREAD_LOCAL_DECLSPEC)
                set(XML_THREAD_LOCAL "__declspec(thread)")
            endif()
        endif()
    endif()
endif()

set(
    LIBXML2_HDRS
    include/libxml/c14n.h
    include/libxml/catalog.h
    include/libxml/chvalid.h
    include/libxml/debugXML.h
    include/libxml/dict.h
    include/libxml/encoding.h
    include/libxml/entities.h
    include/libxml/globals.h
    include/libxml/hash.h
    include/libxml/HTMLparser.h
    include/libxml/HTMLtree.h
    include/libxml/list.h
    include/libxml/nanoftp.h
    include/libxml/nanohttp.h
    include/libxml/parser.h
    include/libxml/parserInternals.h
    include/libxml/pattern.h
    include/libxml/relaxng.h
    include/libxml/SAX.h
    include/libxml/SAX2.h
    include/libxml/schemasInternals.h
    include/libxml/schematron.h
    include/libxml/threads.h
    include/libxml/tree.h
    include/libxml/uri.h
    include/libxml/valid.h
    include/libxml/xinclude.h
    include/libxml/xlink.h
    include/libxml/xmlIO.h
    include/libxml/xmlautomata.h
    include/libxml/xmlerror.h
    include/libxml/xmlexports.h
    include/libxml/xmlmemory.h
    include/libxml/xmlmodule.h
    include/libxml/xmlreader.h
    include/libxml/xmlregexp.h
    include/libxml/xmlsave.h
    include/libxml/xmlschemas.h
    include/libxml/xmlschemastypes.h
    include/libxml/xmlstring.h
    include/libxml/xmlunicode.h
    include/libxml/xmlwriter.h
    include/libxml/xpath.h
    include/libxml/xpathInternals.h
    include/libxml/xpointer.h
)

set(
    LIBXML2_SRCS
    buf.c
    chvalid.c
    dict.c
    encoding.c
    entities.c
    error.c
    globals.c
    hash.c
    list.c
    parser.c
    parserInternals.c
    SAX2.c
    threads.c
    tree.c
    uri.c
    valid.c
    xmlIO.c
    xmlmemory.c
    xmlstring.c
)
if(LIBXML2_WITH_C14N)
    list(APPEND LIBXML2_SRCS c14n.c)
endif()
if(LIBXML2_WITH_CATALOG)
    list(APPEND LIBXML2_SRCS catalog.c)
endif()
if(LIBXML2_WITH_DEBUG)
    list(APPEND LIBXML2_SRCS debugXML.c)
endif()
if(LIBXML2_WITH_HTML)
    list(APPEND LIBXML2_SRCS HTMLparser.c HTMLtree.c)
endif()
if(LIBXML2_WITH_HTTP)
    list(APPEND LIBXML2_SRCS nanohttp.c)
endif()
if(LIBXML2_WITH_LZMA)
    list(APPEND LIBXML2_SRCS xzlib.c)
endif()
if(LIBXML2_WITH_MODULES)
    list(APPEND LIBXML2_SRCS xmlmodule.c)
endif()
if(LIBXML2_WITH_OUTPUT)
    list(APPEND LIBXML2_SRCS xmlsave.c)
endif()
if(LIBXML2_WITH_PATTERN)
    list(APPEND LIBXML2_SRCS pattern.c)
endif()
if(LIBXML2_WITH_READER)
    list(APPEND LIBXML2_SRCS xmlreader.c)
endif()
if(LIBXML2_WITH_REGEXPS)
    list(APPEND LIBXML2_SRCS xmlregexp.c xmlunicode.c)
endif()
if(LIBXML2_WITH_RELAXNG)
    list(APPEND LIBXML2_SRCS relaxng.c)
endif()
if(LIBXML2_WITH_SCHEMAS)
    list(APPEND LIBXML2_SRCS xmlschemas.c xmlschemastypes.c)
endif()
if(LIBXML2_WITH_SCHEMATRON)
    list(APPEND LIBXML2_SRCS schematron.c)
endif()
if(LIBXML2_WITH_WRITER)
    list(APPEND LIBXML2_SRCS xmlwriter.c)
endif()
if(LIBXML2_WITH_XINCLUDE)
    list(APPEND LIBXML2_SRCS xinclude.c)
endif()
if(LIBXML2_WITH_XPATH)
    list(APPEND LIBXML2_SRCS xpath.c)
endif()
if(LIBXML2_WITH_XPTR)
    list(APPEND LIBXML2_SRCS xlink.c xpointer.c)
endif()

if(WIN32)
    list(APPEND LIBXML2_SRCS win32/libxml2.rc)
    file(
        WRITE
        ${CMAKE_CURRENT_BINARY_DIR}/rcVersion.h
        "#define LIBXML_MAJOR_VERSION ${LIBXML_MAJOR_VERSION}\n"
        "#define LIBXML_MINOR_VERSION ${LIBXML_MINOR_VERSION}\n"
        "#define LIBXML_MICRO_VERSION ${LIBXML_MICRO_VERSION}\n"
        "#define LIBXML_DOTTED_VERSION \"${VERSION}\"\n"
    )
endif()

add_library(LibXml2 ${LIBXML2_HDRS} ${LIBXML2_SRCS})
add_library(LibXml2::LibXml2 ALIAS LibXml2)

target_include_directories(
    LibXml2
    PUBLIC
    $<BUILD_INTERFACE:${CMAKE_CURRENT_BINARY_DIR}>
    $<BUILD_INTERFACE:${CMAKE_CURRENT_SOURCE_DIR}/include>
    $<INSTALL_INTERFACE:$<INSTALL_PREFIX>/${CMAKE_INSTALL_INCLUDEDIR}/libxml2>
)

if(LIBXML2_WITH_MODULES)
    check_library_exists(dl dlopen "" HAVE_DLOPEN)
    if(HAVE_DLOPEN)
        target_link_libraries(LibXml2 PRIVATE dl)
        set(MODULE_LIBS "-ldl")
    else()
        check_library_exists(dld shl_load "" HAVE_SHLLOAD)
        if(HAVE_SHLLOAD)
            target_link_libraries(LibXml2 PRIVATE dld)
            set(MODULE_LIBS "-ldld")
        endif()
    endif()
endif()

if(UNIX)
    target_link_libraries(LibXml2 PRIVATE m)
    set(LIBM "-lm")
endif()

if(WIN32)
    target_link_libraries(LibXml2 PRIVATE bcrypt)
    set(CRYPTO_LIBS "-lbcrypt")
    if(LIBXML2_WITH_HTTP)
        target_link_libraries(LibXml2 PRIVATE ws2_32)
        set(WINSOCK_LIBS "-lws2_32")
    endif()
endif()

if(LIBXML2_WITH_ICONV)
    target_link_libraries(LibXml2 PRIVATE Iconv::Iconv)
    if(NOT Iconv_IS_BUILT_IN)
        set(ICONV_LIBS "-liconv")
    endif()
endif()

if(LIBXML2_WITH_ICU)
    target_link_libraries(LibXml2 PRIVATE ICU::uc)
    set(ICU_LDFLAGS "-licuuc")
    list(APPEND XML_PRIVATE_LIBS "${ICU_LDFLAGS}")
    pkg_check_modules(ICU_PC IMPORTED_TARGET icu-uc)
    if(ICU_PC_FOUND)
        list(APPEND XML_PC_REQUIRES icu-uc)
    else()
        list(APPEND XML_PC_LIBS "${ICU_LDFLAGS}")
    endif()
endif()

if(LIBXML2_WITH_LZMA)
    target_link_libraries(LibXml2 PRIVATE LibLZMA::LibLZMA)
    set(LibLZMA_LDFLAGS "-llzma")
    list(APPEND XML_PRIVATE_LIBS "${LibLZMA_LDFLAGS}")
    pkg_check_modules(LibLZMA_PC IMPORTED_TARGET liblzma)
    if(LibLZMA_PC_FOUND)
        list(APPEND XML_PC_REQUIRES liblzma)
    else()
        list(APPEND XML_PC_LIBS "${LibLZMA_LDFLAGS}")
    endif()
endif()

if(LIBXML2_WITH_THREADS)
    target_link_libraries(LibXml2 PRIVATE Threads::Threads)
endif()

if(LIBXML2_WITH_ZLIB)
    target_link_libraries(LibXml2 PRIVATE ZLIB::ZLIB)
    set(ZLIB_LDFLAGS "-lz")
    list(APPEND XML_PRIVATE_LIBS "${ZLIB_LDFLAGS}")
    pkg_check_modules(ZLIB_PC IMPORTED_TARGET zlib)
    if(ZLIB_PC_FOUND)
        list(APPEND XML_PC_REQUIRES zlib)

=== debian/changelog ===
libxml2 (2.14.6+dfsg-0.1) unstable; urgency=medium

  * Non-maintainer upload.
  * New upstream release, drop git-updates patch.

 -- Matthias Klose <doko@debian.org>  Sun, 05 Oct 2025 09:52:40 +0200

libxml2 (2.14.5+dfsg-0.2) unstable; urgency=medium

  * Non-maintainer upload.
  * Update to the 2.14 branch 20250826. Closes: #1111626, #1111803.
  * Fix nopython build profile (Helmut Grohne). Closes: #1078673.

 -- Matthias Klose <doko@debian.org>  Tue, 26 Aug 2025 09:31:15 +0200

libxml2 (2.14.5+dfsg-0.1) unstable; urgency=medium

  * Non-maintainer upload.
  * Update to the 2.14 branch 20250812.
    - CVE-2025-7425: tree: Guard against atype corruption.

 -- Matthias Klose <doko@debian.org>  Wed, 13 Aug 2025 11:52:25 +0200

## libxml2 2.15.0+dfsg

=== debian/changelog ===
libxml2 (2.15.0+dfsg-0.3~mx25+1) mx; urgency=medium

  * Rebuild for MX Linux.

 -- Steven Pusser <stevep@mxlinux.org>  Thu, 16 Oct 2025 11:15:13 -0700

libxml2 (2.15.0+dfsg-0.3) experimental; urgency=medium

  * Non-maintainer upload.
  * New upstream release.
    - Configure with --with-docs.
    - Add build dependencies for building the docs.
    - The devhelp documentation is not built anymore.
  * Update symbols file.
  * Update libxml2-doc doc-base file.

 -- Matthias Klose <doko@debian.org>  Sun, 05 Oct 2025 12:08:07 +0200

=== debian/control ===
Source: libxml2
Priority: optional
Section: libs
Maintainer: Steven Pusser <stevep@mxlinux.org>
XSBC-Original-Maintainer: Debian XML/SGML Group <debian-xml-sgml-pkgs@lists.alioth.debian.org>
Uploaders: Aron Xu <aron@debian.org>, YunQiang Su <wzssyqa@gmail.com>
Build-Depends: debhelper-compat (= 13)
Build-Depends-Indep: docbook-xsl, doxygen <!nopython>, pkgconf, xsltproc
Build-Depends-Arch: dh-sequence-python3 <!nopython>,
                    docbook-xsl,
                    doxygen <!nopython>,
                    liblzma-dev,
                    libpython3-all-dev <!nopython>,
                    libreadline-dev,
                    pkgconf,
                    python3-all-dev:any (>= 3.5) <!nopython>,
                    python3-setuptools <!nopython>,
                    rename,
                    xsltproc,
                    zlib1g-dev | libz-dev
Standards-Version: 4.6.2
Rules-Requires-Root: no
Homepage: http://xmlsoft.org
Vcs-Git: https://salsa.debian.org/xml-sgml-team/libxml2.git
Vcs-Browser: https://salsa.debian.org/xml-sgml-team/libxml2
Description: GNOME XML library
 XML is a metalanguage to let you design your own markup language.
 A regular markup language defines a way to describe information in
 a certain class of documents (eg HTML). XML lets you define your
 own customized markup languages for many classes of document. It
 can do this because it's written in SGML, the international standard
 metalanguage for markup languages.

Package: libxml2-16
Architecture: any
Pre-Depends: ${misc:Pre-Depends}
Depends: ${misc:Depends}, ${shlibs:Depends}
Conflicts: w3c-dtd-xhtml
Breaks: libxml-libxml-perl (<< 2.0207+dfsg+really+2.0134-3~)
Multi-Arch: same
Description: ${source:Synopsis}
 ${source:Extended-Description}
 .
 This package provides a library providing an extensive API to handle
 such XML data files.

Package: libxml2-utils
Architecture: any
Section: text
Depends: ${misc:Depends}, ${shlibs:Depends}
Multi-Arch: foreign
Description: ${source:Synopsis} - utilities
 ${source:Extended-Description}
 .
 This package provides xmllint, a tool for validating and reformatting
 XML documents, and xmlcatalog, a tool to parse and manipulate XML or
 SGML catalog files.

Package: libxml2-dev
Architecture: any
Section: libdevel
Depends: liblzma-dev,
         libxml2-16 (= ${binary:Version}),
         zlib1g-dev,
         ${misc:Depends}
Suggests: pkgconf
Multi-Arch: same
Description: ${source:Synopsis} - development files
 ${source:Extended-Description}
 .
 Install this package if you wish to develop your own programs using
 the GNOME XML library.

Package: libxml2-doc
Architecture: all
Section: doc
Depends: ${misc:Depends}
Suggests: devhelp
Multi-Arch: foreign
Description: ${source:Synopsis} - documentation
 ${source:Extended-Description}
 .
 This package contains general information about the GNOME XML library
 and more specific API references.

Package: python3-libxml2
Architecture: any
Build-Profiles: <!nopython>
Section: python
Depends: ${misc:Depends}, ${python3:Depends}, ${shlibs:Depends}
Description: ${source:Synopsis} - Python3 bindings
 ${source:Extended-Description}
 .
 This package contains the files needed to use the GNOME XML library
 in Python3 programs.

=== debian/rules ===
--- 
+++ 
@@ -23,11 +23,12 @@
 		   --with-xptr-loc \
 		   --with-http \
 		   --with-lzma \
+		   --with-docs \
 
 override_dh_auto_configure-arch: $(TARGETS:%=doconfigure-%)
 
 override_dh_auto_configure-indep:
-	dh_auto_configure -- --docdir \$${prefix}/share/doc/libxml2 --enable-rebuild-docs --with-python=no
+	dh_auto_configure -- --with-docs --docdir \$${prefix}/share/doc/libxml2 --enable-rebuild-docs --with-python=no
 
 doconfigure-%:
 	export PYTHON=$(PYTHON) && dh_auto_configure --builddirectory=builddir/$(*) -- $(CONFIGURE_FLAGS) && unset PYTHON
@@ -69,8 +70,10 @@
 
 override_dh_auto_install-arch: $(TARGETS:%=doinstall-%)
 	find debian/tmp -name *.la -delete
+ifneq ($(PY3VERS),)
 	rm -r debian/tmp/usr/lib/python*/site-packages/__pycache__
 	rm -f debian/tmp/usr/lib/python*/site-packages/*.a
+endif
 
 doinstall-python%:
 	dh_auto_install --builddirectory=builddir/main/python$(*)
@@ -98,6 +101,11 @@
 clean build-arch binary-arch build-indep binary-indep:
 	dh $@
 
+# No dbgsym packages:
+override_dh_strip:
+	@echo "NO--THANKS ANYWAY--but not building dbgsym packages for MX Linux"
+	dh_strip --no-automatic-dbgsym
+
 build: build-arch build-indep
 binary: binary-arch binary-indep

=== debian/tests/control ===
Tests: build python3
Depends: build-essential, libxml2-dev, pkg-config, python3-libxml2

## libxml2 2.15.1%2Bdfsg

=== debian/rules ===
--- 
+++ 
@@ -88,6 +88,29 @@
 	dh_install -a
 	sed -i -e 's,/lib/$(DEB_HOST_MULTIARCH),/lib,' debian/libxml2-dev/usr/bin/xml2-config
 
+DEB_SVERSION    := $(shell dpkg-parsechangelog -S Version | sed 's/-.*//')
+BUILD_DATE := $(shell dpkg-parsechangelog | sed -n -e 's/^Date: //p')
+source_dir := $(shell basename $(CURDIR))
+source_files = $(addprefix $(source_dir)/, \
+                 $(filter-out stamps .pc .git .gitignore debian test result builddir, $(wildcard *)))
+
+override_dh_install-indep:
+	dh_install -i
+
+	mkdir -p debian/libxml2-source/usr/src/libxml2
+	tar -C .. -c -f - $(source_files) | tar -C debian/libxml2-source/usr/src/libxml2 -x -f -
+	-make -C debian/libxml2-source/usr/src/libxml2/$(source_dir) distclean
+	cd debian/libxml2-source/usr/src/libxml2 \
+	  && find -depth -newermt '$(BUILD_DATE)' -print0 | \
+	     xargs -0r touch --no-dereference --date='$(BUILD_DATE)' \
+	  && find  -type f -print0 | LC_ALL=C sort -z | \
+	     tar --null -T - -c --xz --mode=go=rX,u+rw,a-s \
+		--owner=0 --group=0 --numeric-owner --sort=name \
+		--xform='s=^[^/]*\/=libxml2-$(DEB_SVERSION)/=' \
+		-f libxml2-$(DEB_SVERSION).tar.xz \
+		$(source_dir)
+	rm -rf debian/libxml2-source/usr/src/libxml2/$(source_dir)
+
 override_dh_makeshlibs:
 	dh_makeshlibs -plibxml2-16 -V 'libxml2-16 (>= 2.14.1)' -- -c4
 	dh_makeshlibs --remaining-packages
@@ -101,11 +124,6 @@
 clean build-arch binary-arch build-indep binary-indep:
 	dh $@
 
-# No dbgsym packages:
-override_dh_strip:
-	@echo "NO--THANKS ANYWAY--but not building dbgsym packages for MX Linux"
-	dh_strip --no-automatic-dbgsym
-
 build: build-arch build-indep
 binary: binary-arch binary-indep
